SystemOrganization addCategory: #'Glamour-Scripting'!

!GLMPresentation methodsFor: '*Glamour-Scripting' stamp: 'tg 9/25/2010 17:54'!
act: aBlock entitled: aString 
	 
	self 
		addAction: 
			((GLMGenericAction new) 
				action: aBlock; 
				title: aString; 
				yourself)! !

!GLMPresentation methodsFor: '*Glamour-Scripting' stamp: 'tg 9/25/2010 17:54'!
act: aBlock entitled: aString categorized: anotherString
	 
	self 
		addAction: 
			((GLMGenericAction new) 
				action: aBlock; 
				title: aString; 
				category: anotherString;
				yourself)! !

!GLMPresentation methodsFor: '*Glamour-Scripting' stamp: 'tg 9/25/2010 17:53'!
act: aBlock icon: anIcon entitled: aString
	self 
		addAction: 
			((GLMGenericAction new) 
				action: aBlock; 
				icon: anIcon;
				title: aString;
				yourself)! !

!GLMPresentation methodsFor: '*Glamour-Scripting' stamp: 'tg 9/25/2010 17:53'!
act: aBlock on: aCharacter 
	 
	self 
		addAction: 
			((GLMGenericAction new) 
				action: aBlock; 
				shortcut: aCharacter; 
				yourself)! !

!GLMPresentation methodsFor: '*Glamour-Scripting' stamp: 'tg 9/25/2010 17:53'!
act: aBlock on: aCharacter entitled: aString 
	 
	self 
		addAction: 
			((GLMGenericAction new) 
				action: aBlock; 
				shortcut: aCharacter; 
				title: aString; 
				yourself)! !

!GLMPresentation methodsFor: '*Glamour-Scripting' stamp: 'tg 9/25/2010 17:54'!
act: aBlock on: aCharacter entitled: aString categorized: anotherString 
	 
	self 
		addAction: 
			((GLMGenericAction new) 
				action: aBlock; 
				shortcut: aCharacter; 
				title: aString; 
				category: anotherString;
				yourself)! !

!GLMPresentation methodsFor: '*Glamour-Scripting' stamp: 'TudorGirba 11/27/2010 12:37'!
actions: aBlock 
	self deprecated: 'use dynamicActionsOnSelection: for contextual actions, and dynamicActions for presentation-wide actions'.
	^ self dynamicActionsOnSelection: aBlock ! !

!GLMPresentation methodsFor: '*Glamour-Scripting' stamp: 'tg 11/18/2009 15:34'!
allowNil
	^ self useExplicitNotNil! !

!GLMPresentation methodsFor: '*Glamour-Scripting' stamp: ' 4/5/09 22:18'!
display: aBlock 
	 
	self transformation: aBlock! !

!GLMPresentation methodsFor: '*Glamour-Scripting' stamp: 'tg 11/19/2010 18:27'!
dynamicActions: aBlock 
	dynamicActionsBlock := aBlock! !

!GLMPresentation methodsFor: '*Glamour-Scripting' stamp: 'tg 9/26/2010 13:39'!
morphicAct: aBlock entitled: aString 
	 
	self addAction: 
			((GLMMorphicAction new) 
				action: aBlock; 
				title: aString; 
				yourself)! !

!GLMPresentation methodsFor: '*Glamour-Scripting' stamp: 'tg 9/24/2010 16:09'!
morphicAct: aBlock on: aCharacter entitled: aString 
	 
	self 
		addAction: 
			((GLMMorphicAction new) 
				action: aBlock; 
				shortcut: aCharacter; 
				title: aString; 
				yourself)! !

!GLMPresentation methodsFor: '*Glamour-Scripting' stamp: 'TudorGirba 11/25/2010 00:11'!
morphicSelectionAct: aBlock entitled: aString 
	 
	self addSelectionAction: 
			((GLMMorphicAction new) 
				action: aBlock; 
				title: aString; 
				yourself)! !

!GLMPresentation methodsFor: '*Glamour-Scripting' stamp: 'tg 12/29/2009 02:16'!
noSelection
	self acceptsSelection: false! !

!GLMPresentation methodsFor: '*Glamour-Scripting' stamp: 'tg 2/1/2010 22:48'!
noTitle
	title := nil! !

!GLMPresentation methodsFor: '*Glamour-Scripting' stamp: 'tg 9/25/2010 17:53'!
open: aBlock on: aCharacter entitled: aString 
	 
	self 
		addAction: 
			((GLMGenericAction new) 
				action: aBlock; 
				shortcut: aCharacter; 
				title: aString; 
				yourself)! !

!GLMPresentation methodsFor: '*Glamour-Scripting' stamp: 'tg 9/25/2010 17:54'!
populate: aPortSymbol icon: anIcon entitled: aString with: aBlock 
	 
	self 
		addAction: 
			((GLMGenericAction new) 
				action: 
						((GLMPortUpdater new) 
								portSymbol: aPortSymbol; 
								valueBlock: aBlock; 
								yourself); 
				icon: anIcon; 
				title: aString;
				yourself)! !

!GLMPresentation methodsFor: '*Glamour-Scripting' stamp: 'tg 11/19/2010 18:13'!
populate: aPortSymbol on: aCharacter entitled: aString with: aBlock 
	 
	self 
		addAction: 
			((GLMGenericAction new) 
				action: 
						((GLMPortUpdater new) 
								portSymbol: aPortSymbol; 
								valueBlock: aBlock; 
								yourself); 
				shortcut: aCharacter; 
				title: aString;
				yourself)! !

!GLMPresentation methodsFor: '*Glamour-Scripting' stamp: 'tg 9/25/2010 17:54'!
populate: aPortSymbol on: aCharacter with: aBlock
	self addAction: 
			((GLMGenericAction new) 
				action: ((GLMPortUpdater new) 
								portSymbol: aPortSymbol; 
								valueBlock: aBlock; 
								yourself); 
				shortcut: aCharacter; 
				yourself)! !

!GLMPresentation methodsFor: '*Glamour-Scripting' stamp: 'tg 11/20/2010 20:15'!
selectionAct: aBlock entitled: aString 
	 
	self 
		addSelectionAction: 
			((GLMGenericAction new) 
				action: aBlock; 
				title: aString; 
				yourself)! !

!GLMPresentation methodsFor: '*Glamour-Scripting' stamp: 'tg 11/20/2010 20:14'!
selectionAct: aBlock entitled: aString categorized: anotherString
	 
	self 
		addSelectionAction: 
			((GLMGenericAction new) 
				action: aBlock; 
				title: aString; 
				category: anotherString;
				yourself)! !

!GLMPresentation methodsFor: '*Glamour-Scripting' stamp: 'tg 11/20/2010 20:16'!
selectionAct: aBlock icon: anIcon entitled: aString
	self 
		addSelectionAction: 
			((GLMGenericAction new) 
				action: aBlock; 
				icon: anIcon;
				title: aString;
				yourself)! !

!GLMPresentation methodsFor: '*Glamour-Scripting' stamp: 'tg 11/20/2010 20:13'!
selectionAct: aBlock on: aCharacter 
	 
	self 
		addSelectionAction: 
			((GLMGenericAction new) 
				action: aBlock; 
				shortcut: aCharacter; 
				yourself)! !

!GLMPresentation methodsFor: '*Glamour-Scripting' stamp: 'tg 11/19/2010 18:16'!
selectionAct: aBlock on: aCharacter entitled: aString 
	 
	self 
		addSelectionAction: 
			((GLMGenericAction new) 
				action: aBlock; 
				shortcut: aCharacter; 
				title: aString; 
				yourself)! !

!GLMPresentation methodsFor: '*Glamour-Scripting' stamp: 'tg 11/19/2010 18:13'!
selectionPopulate: aPortSymbol on: aCharacter entitled: aString with: aBlock 
	 
	self 
		addSelectionAction: 
			((GLMGenericAction new) 
				action: 
						((GLMPortUpdater new) 
								portSymbol: aPortSymbol; 
								valueBlock: aBlock; 
								yourself); 
				shortcut: aCharacter; 
				title: aString;
				yourself)! !

!GLMPresentation methodsFor: '*Glamour-Scripting' stamp: 'tg 8/25/2009 16:01'!
send: aBlock 
	self selectionTransformation: aBlock! !

!GLMPresentation methodsFor: '*Glamour-Scripting' stamp: ' 4/5/09 22:18'!
when: aBlock 
	 
	self condition: aBlock! !

!GLMPresentation methodsFor: '*Glamour-Scripting' stamp: ' 4/5/09 22:18'!
whenKindOf: aClass 
	 
	self when: [:each | each isKindOf: aClass]! !

!GLMExplicitBrowser methodsFor: '*Glamour-Scripting-deprecated' stamp: 'tg 1/11/2010 20:39'!
custom: aPresentation 
	"this message sets a custom presentation to the current Transmission. 
	it is to be used within the using: block. 
	this message is particularly useful when you want to set a browser as a presentation" 
	 
	self lastTransmission addPresentation: aPresentation. 
	^ aPresentation! !

!GLMExplicitBrowser methodsFor: '*Glamour-Scripting-deprecated' stamp: 'tg 1/11/2010 20:38'!
from: anOriginPortReference 
	"send this message after showOn: to specify an origin for the Transmission. 
	you can cascade several from: to specify additional origins" 
	 
	self lastTransmission 
		addActiveOrigin: (self resolveOriginPort: anOriginPortReference)! !

!GLMExplicitBrowser methodsFor: '*Glamour-Scripting-deprecated' stamp: 'TudorGirba 12/2/2010 20:10'!
fromOutside: aPortName
	 ^ self fromOutsidePort: aPortName! !

!GLMExplicitBrowser methodsFor: '*Glamour-Scripting-deprecated' stamp: 'TudorGirba 12/2/2010 20:10'!
fromOutsidePort: aPortName
	 ^ self from: #outer->aPortName! !

!GLMExplicitBrowser methodsFor: '*Glamour-Scripting-deprecated' stamp: 'tg 1/11/2010 20:38'!
passivelyFrom: anOriginPortReference 
	"passivelyForm: is similar to from: only the origin will be a passive one. 
	in other words, a change in the origin port will not initiate a Transmission" 
	 
	self lastTransmission
		addPassiveOrigin: (self resolveOriginPort: anOriginPortReference)! !

!GLMExplicitBrowser methodsFor: '*Glamour-Scripting-deprecated' stamp: 'tg 1/14/2010 16:10'!
sendTo: aDesinationPortReference from: anOriginPortReference 
	"this message links two port references with a transmission that holds no presentation" 
	 
	self transmissions 
		addLast: 
			((GLMTransmission new) 
				addActiveOrigin: (self resolveOriginPort: anOriginPortReference); 
				destination: (self resolveDestinationPort: aDesinationPortReference); 
				yourself)! !

!GLMExplicitBrowser methodsFor: '*Glamour-Scripting-deprecated' stamp: 'tg 1/14/2010 16:10'!
sendTo: aDesinationPortReference from: anOriginPortReference with: aBlock 
	"this message links two port references with a transmission that holds no presentation" 
	 
	self transmissions 
		addLast: 
			((GLMTransmission new) 
				addActiveOrigin: (self resolveOriginPort: anOriginPortReference); 
				destination: (self resolveDestinationPort: aDesinationPortReference); 
				transformation: aBlock; 
				yourself)! !

!GLMExplicitBrowser methodsFor: '*Glamour-Scripting-deprecated' stamp: ' 4/5/09 22:18'!
sendTo: aDesinationPortReference fromOutside: anOriginPortName 
	"this is a shortcut method for propagating inside an outer port name to an inner port reference" 
	 
	self 
		sendTo: aDesinationPortReference 
		from: #outer -> anOriginPortName! !

!GLMExplicitBrowser methodsFor: '*Glamour-Scripting-deprecated' stamp: ' 4/5/09 22:18'!
sendToOutside: aPortName from: anOriginPortReference 
	"this is a shortcut method for exposing an inner port reference as an outer port name" 
	 
	self 
		sendTo: #outer -> aPortName 
		from: anOriginPortReference! !

!GLMExplicitBrowser methodsFor: '*Glamour-Scripting-deprecated' stamp: 'tg 1/14/2010 16:51'!
showOn: aDestinationPane 
	"send this message when at the beginning of specifying a Transmission" 
	 
	self addTransmission: (
		GLMTransmission new
			ensureBundleStrategy;
			destination: (self resolveDestinationPort: aDestinationPane); 
			yourself)! !

!GLMExplicitBrowser methodsFor: '*Glamour-Scripting-deprecated' stamp: 'tg 1/11/2010 20:38'!
using: aBlock 
	"this message should be sent after showOn: and a sequence of from: messages. 
	the using: message takes a block as a parameter to specify the presentations that accompany the Transmission" 
	 
	aBlock value. 
	self lastTransmission origins isEmpty ifTrue: [self from: #outer->#entity]! !

!GLMTablePresentation methodsFor: '*Glamour-Scripting' stamp: 'tg 11/16/2009 03:31'!
column: aBlockOrString evaluated: aBlock
	self addColumn: (GLMTableColumn new title: aBlockOrString; computation: aBlock)! !

!GLMTabulator methodsFor: '*Glamour-Scripting' stamp: ' 4/5/09 22:18'!
column: aBlockOrSymbol 
	 
	^self addColumn: aBlockOrSymbol! !

!GLMTabulator methodsFor: '*Glamour-Scripting' stamp: 'tg 10/22/2009 13:27'!
column: aBlockOrSymbol size: anInteger 
	 
	^self addColumn: aBlockOrSymbol size: anInteger! !

!GLMTabulator methodsFor: '*Glamour-Scripting' stamp: ' 4/5/09 22:18'!
column: aBlockOrSymbol span: anInteger 
	 
	^self addColumn: aBlockOrSymbol span: anInteger! !

!GLMTabulator methodsFor: '*Glamour-Scripting' stamp: 'tg 12/29/2009 16:48'!
initializeScriptingDefaults 
	 
	super initializeScriptingDefaults. 
	self cell isNil ifTrue: [self addColumn: #pane].
	self transmissions 
		detect: [ :each | each originatesAt: (self pane port: #entity) ]
		ifNone: [
			self 
				showOn: (self panes first port: #entity);
				from: #outer->#entity;
				using: [ self custom: GLMFlexiblePresentation new ] ]! !

!GLMTabulator methodsFor: '*Glamour-Scripting' stamp: ' 4/5/09 22:18'!
row: aBlockOrSymbol 
	 
	^self addRow: aBlockOrSymbol! !

!GLMTabulator methodsFor: '*Glamour-Scripting' stamp: 'tg 10/22/2009 13:26'!
row: aBlockOrSymbol size: anInteger 
	 
	^self addRow: aBlockOrSymbol size: anInteger! !

!GLMTabulator methodsFor: '*Glamour-Scripting' stamp: ' 4/5/09 22:18'!
row: aBlockOrSymbol span: anInteger 
	 
	^self addRow: aBlockOrSymbol span: anInteger! !

Object subclass: #Glamorous
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Scripting'!

!Glamorous commentStamp: 'tg 9/20/2009 13:59' prior: 0!
A Glamorous is just a library of browsers stored as methods on the class side.!

!Glamorous classSide methodsFor: 'as yet unclassified' stamp: 'tg 9/5/2010 16:12'!
editor
	"self editor openOn: '| browser |'"
	| browser |
	browser := GLMTabulator new.
	browser row: #browser; row: #source.
	browser title: 'Glamorous Editor'.
	browser transmit to: #source; andShow: [ :a |
		a text
			title: 'Editor';
			forSmalltalk;
			populate: #selection on: $o entitled: 'Open (o)' with: [:text | text text]].
	browser transmit to: #browser; from: #source; andShow: [ :a |
		a dynamic
			title: 'Preview';
			display: [:source | 
				(Compiler evaluate: source logged: false)]].
	^ browser! !

!MOViewRenderer methodsFor: '*glamour-scripting' stamp: 'tg 5/7/2010 21:53'!
openWithStatusbar
	| browser |
	browser := GLMTabulator withStatusbar.
	browser act: [:b | b panes last presentations first view canvas exportAsPNG] entitled: 'Export as PNG'.
	browser title: 'Mondrian painting'.
	browser column: #painting.
	browser transmit to: #painting; andShow: [ :a | 
		a mondrian view: self ].
	^ browser openOn: self! !

!GLMCustomColumn methodsFor: '*Glamour-Scripting' stamp: ' 4/5/09 22:18'!
row: aBlockOrSymbol 
	 
	^self addRow: aBlockOrSymbol! !

!GLMCustomColumn methodsFor: '*Glamour-Scripting' stamp: 'tg 10/21/2009 22:08'!
row: aBlockOrSymbol size: anInteger 
	 
	^self addRow: aBlockOrSymbol size: anInteger! !

!GLMCustomColumn methodsFor: '*Glamour-Scripting' stamp: ' 4/5/09 22:18'!
row: aBlockOrSymbol span: anInteger 
	 
	^self addRow: aBlockOrSymbol span: anInteger! !

!GLMActionListPresentation methodsFor: '*Glamour-Scripting' stamp: 'tg 11/8/2009 20:54'!
beHorizontal
	self isHorizontal: true! !

!GLMTransmission methodsFor: '*Glamour-Scripting' stamp: 'tg 1/14/2010 21:53'!
andShow: aBlock
	self ensureBundleStrategy.
	self origins isEmpty ifTrue: [self from: #outer->#entity].
	aBlock value: self transmissionStrategy presentations! !

!GLMTransmission methodsFor: '*Glamour-Scripting' stamp: 'tg 2/20/2010 16:29'!
andShowIfNone: aBlock
	self ensureNoOverrideBundleStrategy.
	self origins isEmpty ifTrue: [self from: #outer->#entity].
	aBlock value: self transmissionStrategy presentations! !

!GLMTransmission methodsFor: '*Glamour-Scripting' stamp: 'tg 2/20/2010 16:30'!
andShowWithoutOverride: aBlock
	self deprecated: 'Please use andShowIfNone: instead'.
	^ self andShowIfNone: aBlock! !

!GLMTransmission methodsFor: '*Glamour-Scripting' stamp: 'tg 1/14/2010 23:26'!
from: aPort
	^ self addActiveOrigin: (self browser resolveOriginPort: aPort)! !

!GLMTransmission methodsFor: '*Glamour-Scripting' stamp: 'tg 11/3/2010 13:37'!
from: aPaneSymbol port: aPortSymbol
	^ self from: (GLMPortIdentifier pane: aPaneSymbol port: aPortSymbol)! !

!GLMTransmission methodsFor: '*Glamour-Scripting' stamp: 'tg 1/14/2010 23:26'!
from: aPort transformed: aBlock
	^ (self addActiveOrigin: (self browser resolveOriginPort: aPort)) transformation: aBlock! !

!GLMTransmission methodsFor: '*Glamour-Scripting' stamp: 'TudorGirba 12/2/2010 20:10'!
fromOutside: aPortSymbol
	^ self fromOutsidePort: aPortSymbol! !

!GLMTransmission methodsFor: '*Glamour-Scripting' stamp: 'TudorGirba 12/2/2010 20:10'!
fromOutsidePort: aPortSymbol
	^ self from: #outer->aPortSymbol! !

!GLMTransmission methodsFor: '*Glamour-Scripting' stamp: 'tg 2/20/2010 18:21'!
passivelyFrom: aPort
	^ self addPassiveOrigin: (self browser resolveOriginPort: aPort)! !

!GLMTransmission methodsFor: '*Glamour-Scripting' stamp: 'tg 1/14/2010 23:26'!
to: aPort
	^ self destination: (self browser resolveDestinationPort: aPort)! !

!GLMTransmission methodsFor: '*Glamour-Scripting' stamp: 'tg 11/3/2010 13:36'!
to: aPaneSymbol port: aPortSymbol
	^ self to: (GLMPortIdentifier pane: aPaneSymbol port: aPortSymbol)! !

!GLMTransmission methodsFor: '*Glamour-Scripting' stamp: 'TudorGirba 12/2/2010 20:09'!
toOutside: aPortSymbol
	^ self toOutsidePort: aPortSymbol! !

!GLMTransmission methodsFor: '*Glamour-Scripting' stamp: 'TudorGirba 12/2/2010 20:09'!
toOutsidePort: aPortSymbol
	^ self to: #outer->aPortSymbol! !

!GLMTransmission methodsFor: '*Glamour-Scripting' stamp: 'tg 1/31/2010 01:52'!
transformed: aBlock
	self transformation: aBlock! !

!GLMTransmission methodsFor: '*Glamour-Scripting' stamp: 'tg 1/31/2010 01:44'!
when: aBlock
	self condition: aBlock! !

!GLMFinder methodsFor: '*Glamour-Scripting' stamp: 'tg 1/15/2010 02:26'!
fromPrevious: aPortSymbol
	self scriptTransmission addActiveOrigin: (GLMPort new name: aPortSymbol)! !

!GLMFinder methodsFor: '*Glamour-Scripting' stamp: 'tg 1/14/2010 16:05'!
passivelyFromPrevious: aPortSymbol
	self scriptTransmission addPassiveOrigin: (GLMPort new name: aPortSymbol)! !

!GLMFinder methodsFor: '*Glamour-Scripting' stamp: ' 4/5/09 22:18'!
using: aBlock 
	 
	aBlock value. 
	self addTransmission: scriptTransmission. 
	scriptTransmission := nil! !

!GLMCompositePresentation methodsFor: '*Glamour-Scripting' stamp: 'tg 1/6/2010 23:15'!
accordionArrangement
	^ self arrangement: GLMAccordionArrangement new! !

!GLMCompositePresentation methodsFor: '*Glamour-Scripting' stamp: 'tg 1/5/2010 15:59'!
custom: aPresentation
	^ self add: aPresentation! !

!GLMCompositePresentation methodsFor: '*Glamour-Scripting' stamp: 'tg 1/14/2010 02:56'!
stackedArrangement
	^ self stackedVerticallyArrangement! !

!GLMCompositePresentation methodsFor: '*Glamour-Scripting' stamp: 'tg 1/12/2010 14:37'!
stackedVerticallyArrangement
	^ self arrangement: (GLMStackedVerticallyArrangement of: self)! !

!GLMCompositePresentation methodsFor: '*Glamour-Scripting' stamp: 'tg 1/14/2010 17:21'!
tabbedArrangement
	^ self arrangement: GLMTabbedArrangement new! !

!GLMCompositePresentation methodsFor: '*Glamour-Scripting' stamp: 'tg 1/12/2010 14:37'!
verticallyStackedArrangement
	^ self stackedVerticallyArrangement! !

!GLMTPresentationBuilder methodsFor: '*glamour-scripting-presentations' stamp: 'tg 1/5/2010 15:50'!
actionList
	^ self custom: GLMActionListPresentation new! !

!GLMTPresentationBuilder methodsFor: '*glamour-scripting-presentations' stamp: 'tg 1/6/2010 10:41'!
composite: aBlock
	| composite |
	composite := GLMCompositePresentation new.
	aBlock value: composite.
	^ self custom: composite! !

!GLMTPresentationBuilder methodsFor: '*glamour-scripting-presentations' stamp: 'tg 1/5/2010 15:50'!
diff
	^ self custom: GLMDiffPresentation new! !

!GLMTPresentationBuilder methodsFor: '*glamour-scripting-presentations' stamp: 'VeronicaUquillas 5/26/2010 13:46'!
dropDownList
	^ self custom: GLMDropDownListPresentation new! !

!GLMTPresentationBuilder methodsFor: '*glamour-scripting-presentations' stamp: 'tg 1/5/2010 15:50'!
dynamic
	^ self custom: GLMDynamicPresentation new! !

!GLMTPresentationBuilder methodsFor: '*glamour-scripting-presentations' stamp: 'tg 1/5/2010 15:50'!
finder
	^ self custom: GLMFinder new! !

!GLMTPresentationBuilder methodsFor: '*glamour-scripting-presentations' stamp: 'tg 3/30/2010 23:11'!
label
	^ self custom: GLMLabelPresentation new! !

!GLMTPresentationBuilder methodsFor: '*glamour-scripting-presentations' stamp: 'tg 1/5/2010 15:50'!
list 
	^ self custom: GLMListPresentation new! !

!GLMTPresentationBuilder methodsFor: '*glamour-scripting-presentations' stamp: 'tg 1/5/2010 15:50'!
magritte
	^ self custom: GLMMagrittePresentation new! !

!GLMTPresentationBuilder methodsFor: '*glamour-scripting-presentations' stamp: 'tg 1/5/2010 15:50'!
mondrian 
	^ self custom: GLMMondrianPresentation new! !

!GLMTPresentationBuilder methodsFor: '*glamour-scripting-presentations' stamp: 'tg 1/5/2010 15:50'!
morph
	^ self custom: GLMMorphPresentation new! !

!GLMTPresentationBuilder methodsFor: '*glamour-scripting-presentations' stamp: 'tg 1/5/2010 15:50'!
table
	^ self custom: GLMTablePresentation new! !

!GLMTPresentationBuilder methodsFor: '*glamour-scripting-presentations' stamp: 'tg 1/5/2010 15:50'!
tabulator
	^ self custom: GLMTabulator new! !

!GLMTPresentationBuilder methodsFor: '*glamour-scripting-presentations' stamp: 'tg 1/5/2010 15:50'!
text 
	^ self custom: GLMTextPresentation new! !

!GLMTPresentationBuilder methodsFor: '*glamour-scripting-presentations' stamp: 'tg 1/5/2010 15:50'!
tree 
	^ self custom: GLMTreePresentation new! !

!GLMDynamicPresentation methodsFor: '*Glamour-Scripting' stamp: 'tg 2/28/2010 23:11'!
presentation: aBlock
	self presentationTransformation: aBlock! !

!GLMDynamicPresentation methodsFor: '*Glamour-Scripting' stamp: 'tg 3/1/2010 00:51'!
with: aBlock
	self presentationTransformation: aBlock! !

!GLMImplicitBrowser methodsFor: '*Glamour-Scripting' stamp: 'tg 1/17/2010 06:07'!
custom: aPresentation 
	 
	scriptTransmission isNil 
		ifTrue: [self addPresentation: aPresentation] 
		ifFalse: [self scriptTransmission addPresentation: aPresentation]. 
	^aPresentation! !

!GLMImplicitBrowser methodsFor: '*Glamour-Scripting' stamp: 'tg 1/17/2010 06:06'!
scriptTransmission
	^ scriptTransmission 
		ifNil: [scriptTransmission := GLMTransmission new ensureBundleStrategy]! !

!GLMImplicitBrowser methodsFor: '*Glamour-Scripting' stamp: 'tg 1/17/2010 06:06'!
show: aBlock
	^ aBlock value: self presentations! !

!GLMCustomRow methodsFor: '*Glamour-Scripting' stamp: ' 4/5/09 22:18'!
column: aBlockOrSymbol 
	 
	^self addColumn: aBlockOrSymbol! !

!GLMCustomRow methodsFor: '*Glamour-Scripting' stamp: 'tg 10/21/2009 22:08'!
column: aBlockOrSymbol size: anInteger 
	 
	^self addColumn: aBlockOrSymbol size: anInteger! !

!GLMCustomRow methodsFor: '*Glamour-Scripting' stamp: ' 4/5/09 22:18'!
column: aBlockOrSymbol span: anInteger 
	 
	^self addColumn: aBlockOrSymbol span: anInteger! !

!GLMBrowser classSide methodsFor: '*glamour-scripting' stamp: 'tg 4/1/2010 07:01'!
withStatusbar
	^ self new addStatusbar! !

!GLMBrowser methodsFor: '*glamour-scripting' stamp: 'jorge.ressia 6/2/2009 17:11'!
context

	^OrderedCollection new! !

!GLMBrowser methodsFor: '*glamour-scripting' stamp: ' 4/5/09 22:18'!
custom: aPresentation 
	 
	self subclassResponsibility! !

!GLMBrowser methodsFor: '*glamour-scripting' stamp: ' 4/5/09 22:18'!
defaultRenderer 
	 
	^GLMRenderer subclasses first new! !

!GLMBrowser methodsFor: '*glamour-scripting' stamp: 'tg 5/24/2009 19:15'!
initializeScriptingDefaults 
	"Initialize some default behavior if the user did not explcitly script it. 
 
	Subclasses can use this to create a default startup transmission or show 
	a default pane or something like that." 
	
	^self! !

!GLMBrowser methodsFor: '*glamour-scripting' stamp: ' 4/5/09 22:18'!
open 
	 
	^self openWith: self defaultRenderer! !

!GLMBrowser methodsFor: '*glamour-scripting' stamp: ' 4/5/09 22:18'!
openOn: anObject 
	 
	^self 
		openOn: anObject 
		with: self defaultRenderer! !

!GLMBrowser methodsFor: '*glamour-scripting' stamp: ' 4/5/09 22:18'!
openOn: anObject with: aRenderer 
	 
	self startOn: anObject. 
	^aRenderer open: self! !

!GLMBrowser methodsFor: '*glamour-scripting' stamp: ' 4/5/09 22:18'!
openWith: aRenderer 
	 
	^self openOn: nil with: aRenderer! !

!GLMBrowser methodsFor: '*glamour-scripting' stamp: 'tg 5/18/2010 13:50'!
screenshot: aFilenameString on: anObject after: aBlock
	 
	| window |
	window := self openOn: anObject.
	aBlock glamourValue: self asGlamorousMultiValue.
	World doOneCycle.
	PNGReadWriter putForm: window imageForm onFileNamed: aFilenameString.
	^ window! !

!GLMBrowser methodsFor: '*glamour-scripting' stamp: ' 4/5/09 22:18'!
startOn: anObject 
	 
	self initializeScriptingDefaults. 
	self entity: anObject! !

!GLMBrowser methodsFor: '*glamour-scripting' stamp: 'tg 1/18/2010 13:29'!
transmit
	^ self addTransmission: (GLMTransmission new browser: self; yourself)! !

!GLMListingPresentation methodsFor: '*Glamour-Scripting' stamp: 'tg 12/29/2009 00:24'!
allowDeselection
	self allowsDeselection: true! !

!GLMListingPresentation methodsFor: '*Glamour-Scripting' stamp: 'tg 10/5/2009 00:36'!
beMultiple
	allowsMultipleSelection := true! !

!GLMListingPresentation methodsFor: '*Glamour-Scripting' stamp: 'tg 10/5/2009 00:37'!
beSingle
	allowsMultipleSelection := false! !

!GLMListingPresentation methodsFor: '*Glamour-Scripting' stamp: 'tg 9/22/2009 08:36'!
filterOn: aBlock 
	filterBlock := aBlock! !

!GLMListingPresentation methodsFor: '*Glamour-Scripting' stamp: 'tg 9/22/2009 08:40'!
searchOn: aBlock
	searchBlock := aBlock! !

!GLMListingPresentation methodsFor: '*Glamour-Scripting' stamp: 'tg 9/30/2009 01:28'!
showOnly: aBlock
	amountToShowBlock := aBlock! !

!GLMListingPresentation methodsFor: '*Glamour-Scripting' stamp: 'VeronicaUquillas 11/19/2009 19:25'!
tags: anObject
	tagsBlock := anObject.
	self hasTagsFilter ifFalse:[ tagsFilterBlock := anObject ]! !

!GLMListingPresentation methodsFor: '*Glamour-Scripting' stamp: 'VeronicaUquillas 11/2/2009 11:03'!
tagsFilter: anObject
	tagsFilterBlock := anObject ! !
